Bug 146622 - Crash swlo!SwNodeIndex::SwNodeIndex+0x83:
Summary: Crash swlo!SwNodeIndex::SwNodeIndex+0x83:
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
7.4.0.0 alpha0+ Master
Hardware: All All
: medium normal
Assignee: László Németh
URL:
Whiteboard: target:7.4.0 target:7.3.1
Keywords: bibisected, bisected, regression
Depends on:
Blocks: Undo-Redo
  Show dependency treegraph
 
Reported: 2022-01-06 17:50 UTC by Telesto
Modified: 2022-03-17 14:59 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments
Example file (29.32 KB, application/vnd.oasis.opendocument.text)
2022-01-06 17:52 UTC, Telesto
Details
BT without symbols (13.44 KB, text/plain)
2022-01-06 17:53 UTC, Telesto
Details
tail of teminal output, bibisect repository linux-64-7.3 (3.26 KB, text/plain)
2022-02-12 03:01 UTC, Terrence Enger
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Telesto 2022-01-06 17:50:45 UTC
Description:
Crash swlo!SwNodeIndex::SwNodeIndex+0x83:

Steps to Reproduce:
1. open the attached file
2. Scroll to bottom, place cursor in the right bottom cell
3. Press delete row 20 times
4. Press CTRL+Z (or eventually few more steps back)

Actual Results:
Crash

Expected Results:
No crash


Reproducible: Always


User Profile Reset: No



Additional Info:
Version: 7.4.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: 1bb0e177124d5d6661b72df6c7d848fb23639652
CPU threads: 4; OS: Windows 6.3 Build 9600; UI render: Skia/Raster; VCL: win
Locale: nl-NL (nl_NL); UI: en-US
Calc: CL
Comment 1 Telesto 2022-01-06 17:52:08 UTC
Created attachment 177353 [details]
Example file
Comment 2 Telesto 2022-01-06 17:53:55 UTC
Created attachment 177354 [details]
BT without symbols
Comment 3 Dieter 2022-01-10 17:06:06 UTC
No crash in

Version: 7.2.5.2 (x64) / LibreOffice Community
Build ID: 499f9727c189e6ef3471021d6132d4c694f357e5
CPU threads: 4; OS: Windows 10.0 Build 19044; UI render: Skia/Raster; VCL: win
Locale: de-DE (de_DE); UI: en-GB
Calc: CL

Will test with master later.
Comment 4 Dieter 2022-01-11 20:07:39 UTC
Crash with

Version: 7.4.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: 151c56ed547490a99d912524c0e56b5d6d4a1939
CPU threads: 4; OS: Windows 10.0 Build 19044; UI render: default; VCL: win
Locale: de-DE (de_DE); UI: de-DE
Calc: threaded
Comment 5 Terrence Enger 2022-02-12 03:01:12 UTC
Created attachment 178234 [details]
tail of teminal output, bibisect repository linux-64-7.3

Working in bibisect repo linux-64-7.3 on debian-buster, I see ...

          commit    s-h       date
          --------  --------  -------------------
    good  0fd39614  160b6db9  2021-09-08 13:18:52
    bad   772a8347  99059a1e  2021-09-03 13:28:00

I am removing keyword bibisectRequest and adding bibisected and
bisected.
Comment 6 Telesto 2022-02-12 09:13:33 UTC
commit 99059a1ececa3621c2fe46fabdd79eed9d626c42	[log]
author	László Németh <nemeth@numbertext.org>	Tue Sep 07 15:57:35 2021 +0200
committer	László Németh <nemeth@numbertext.org>	Wed Sep 08 15:28:00 2021 +0200
tree 2f34d312d7a32dae47f61f2c20d8553e0bb0c222
parent 160b6db92cc94f2ec2447ae0e9c60c8c9dcf3bad [diff]
tdf#143359 sw: track deletion of empty table rows

Empty table rows were deleted immediately during
change tracking, or in the case of a deleted table
also with non-empty rows, accepting table deletion
kept empty rows.

Note: as a workaround for tracking of the empty rows,
i.e. rows without text content, add a redline with
invisible text ZWJ in the first cell of the empty row.

See also commit a483a44ca00f43a64ae51d62b8fbb4129a413f6d
"tdf#143215 DOCX import: fix tracked empty row insertion/deletion",
commit b50d386dfa70f7c1d4eb1a49091ec9dd782b767b
"tdf#142701 track changes: fix layout regression of image deletion"
and commit 05366b8e6683363688de8708a3d88cf144c7a2bf
"tdf#60382 sw offapi: add change tracking of table/row deletion".

Note: switch off unnecessary redlining of tdf#132744 unit test
to keep the sake of that test (i.e. cut of the selected table
with empty rows)

https://git.libreoffice.org/core/+/99059a1ececa3621c2fe46fabdd79eed9d626c42%5E!
Comment 7 Telesto 2022-02-12 09:14:11 UTC
Adding CC: to László Németh
Comment 8 Commit Notification 2022-02-16 19:34:45 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/95213407dfcbf34056037d60243ff915340d1a2e

tdf#146622 sw crash fix: don't delete already deleted rows

It will be available in 7.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 9 Commit Notification 2022-02-16 19:35:57 UTC
László Németh committed a patch related to this issue.
It has been pushed to "libreoffice-7-3":

https://git.libreoffice.org/core/commit/6b80222d6bc043eb78a2986e9051cee3e5ee0967

tdf#146622 sw crash fix: don't delete already deleted rows

It will be available in 7.3.2.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 10 László Németh 2022-02-16 19:38:16 UTC
@Telesto: thanks for reporting and bibisecting!

Commit description:

tdf#146622 sw crash fix: don't delete already deleted rows

Delete tables and rows removed also tables and table rows
with tracked row deletion/insertion. This resulted not only
lost change tracking, but a crashing Undo.

Crash regression from commit 99059a1ececa3621c2fe46fabdd79eed9d626c42
"tdf#143359 sw: track deletion of empty table rows".

Non-tracked deletion of the tracked row changes was a
temporary solution for the missing UI of tracked
row changes, implemented in commit 05366b8e6683363688de8708a3d88cf144c7a2bf
"tdf#60382 sw offapi: add change tracking of table/row deletion".

Note: UI was added in commit f348440e17debacbcba9153e238e010e8c020bdc
"tdf#146120 sw: show tracked table changes with different color",
commit 95c003d75e0f8b255344715a35358072b5eba99d
"tdf#146145 sw: 1-click Accept/Reject of table row changes",
commit 84fbb3398f7486f00e7b7dea415e1ea2510a9535
"tdf#146144 sw: add tooltip to table rows with change tracking",
commit eebe4747d2d13545004937bb0267ccfc8ab9d63f
"tdf#144270 sw: manage tracked table (row) deletion/insertion",
commit f481c2c8e74bded11fac754e493560391229dbcd
"tdf#144057 sw track changes: hide deleted table rows" and
commit 23846867ea32667ccf328c36142394dd6aaee8ba
"tdf#147182 sw: accept/reject all changes of a table selection".

Change-Id: I384b750b0d3626fa8b3f256c7eaf5b93f382e4e5
Comment 11 Telesto 2022-02-16 19:47:58 UTC
(In reply to László Németh from comment #10)
> @Telesto: thanks for reporting and bibisecting!

Bibisect credits go to Terrence (comment 5)

Thanks for the quick fix!
Comment 12 László Németh 2022-02-16 21:14:39 UTC
@Terrence: thanks for bibisecting!

(In reply to Telesto from comment #11)
> (In reply to László Németh from comment #10)
> > @Telesto: thanks for reporting and bibisecting!
> 
> Bibisect credits go to Terrence (comment 5)
> 
> Thanks for the quick fix!

Ah, ok. You are welcome! Thanks for your help!
Comment 13 Commit Notification 2022-02-21 17:42:51 UTC
László Németh committed a patch related to this issue.
It has been pushed to "libreoffice-7-3-1":

https://git.libreoffice.org/core/commit/b907c008c2c65ca461097cfc636883331fd1357c

tdf#146622 sw crash fix: don't delete already deleted rows

It will be available in 7.3.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 14 NISZ LibreOffice Team 2022-03-08 07:30:18 UTC
Verified in
Version: 7.4.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: 6adabd915d931b845fcf2fef15fbf3fca14ec9b3
CPU threads: 4; OS: Windows 10.0 Build 18363; UI render: Skia/Raster; VCL: win
Locale: hu-HU (hu_HU); UI: en-US
Calc: threaded